using System;
using System.Collections.Generic;

namespace PrimeFactors
{
    public static class PrimeFactors
    {
        public static IEnumerable<int> Primes(this int n)
        {
            var primes = new List<int>();
            for (var divider = 2; divider <= Math.Sqrt(n); divider++)
                for (; n % divider == 0; n /= divider)
                    primes.Add(divider);
            if (n > 1)
                primes.Add(n);
            return primes;
        }
    }
}