﻿using System.Collections.Generic;
using NBehave.Spec.NUnit;
using NUnit.Framework;

namespace PrimeFactors
{
    [TestFixture]
    public class When_factoring
    {
        [Test]
        public void Should_factor_one()
        {
            1.Primes().ShouldEqual(new List<int>());
        }

        // [TestCase(1, new int[0])] this is to delete the first duplicate test which runs ok on its own. Uncomment it and the resharper test runner session will hang.
        [TestCase(2, new[]{2})]
        [TestCase(3, new[]{3})]
        [TestCase(4, new[]{2, 2})]
        [TestCase(6, new[]{2, 3})]
        [TestCase(8, new[]{2, 2, 2})]
        [TestCase(9, new[]{3, 3})]
        [TestCase(2*3*5*7*11*13, new[]{2, 3, 5, 7, 11, 13})]
        [TestCase(int.MaxValue, new[]{int.MaxValue})]
        public void Should_factor(int number, int[] expected)
        {
            number.Primes().ShouldEqual(expected);
        }
    }
}